﻿#SingleInstance Force
#NoEnv

SetWorkingDir %A_ScriptDir%
SetBatchLines -1
Menu, Tray, NoStandard

; ############################################
; ########### GLOBAL VARIABLES ###############
; ############################################

program_lnk_startup_path = %A_Startup%\%A_ScriptName%
SplitPath, program_lnk_startup_path, name, dir, ext, name_no_ext
program_lnk_startup_path = %dir%\%name_no_ext%.lnk

;variables for UI
global ppt_tools_gui :=
global gui_hotkey_list :=
global gui_hotkey_setting :=
global active_ppt_frame :=
global vHotkeyListView
global string_hotkey_registration_error_lang_layout :=

;variables for storing ppt shapes attributes
global ppt_last_copied_position_left :=
global ppt_last_copied_position_top :=
global ppt_last_copied_position_right :=
global ppt_last_copied_position_bottom :=
global ppt_last_copied_width :=
global ppt_last_copied_height :=
global ppt_last_copied_rounded_corner_radius :=

global b_IsHighPriorityTooltipStillOn := false


;variables for user configs
ini_file = config.ini
str_hotkey_list_GUI_title :=
ppt_ini_hk_section = PowerPointHotkeys
xl_ini_hk_section = ExcelHotkeys
cmdList_file = res\functions
ppt_cmdList_section = PowerPointCommands
xl_cmdList_section = ExcelCommands


; ############################################
; ############# INITIALIZATION ###############
; ############################################

Iniread, HotkeyVar1, Config.ini, Hotkeys, ToggleUIHotkey1
Iniread, HotkeyVar2, Config.ini, Hotkeys, ToggleUIHotkey2
Hotkey, %HotkeyVar1%,ToggleUIKey1,On
Hotkey, %HotkeyVar2%,ToggleUIKey2,On

gosub, Configs_Readiness_Check
gosub, Create_QQPPT_Tools_GUI
gosub, RegisterHotkeysForPowerPoint
gosub, RegisterHotkeysForExcel
gosub, ShowHotkeysRegistrationErrorIfAny
gosub, CreateSystemTrayMenuItems

return

; ############################################
; ########## PREPARE A FEW STUFF #############
; ############################################

Configs_Readiness_Check:
{
    s_ini_general_section := "General"
    s_auto_close_ppttools_after_execution_config_key := "AutoClosePPTToolsGUIAfterAction"
    IniRead, b_auto_close_ppttools_after_execution, % ini_file, % s_ini_general_section
    if (b_auto_close_ppttools_after_execution = ""){
        IniWrite, True, % ini_file, % s_ini_general_section, % s_auto_close_ppttools_after_execution_config_key
    }
    
    return
}

CreateSystemTrayMenuItems:
{
    Menu, Tray, Add, Hotkeys for Excel, ShowXlHotkeySettingsUI
    Menu, Tray, Add, Hotkeys for PowerPoint, ShowPptHotkeySettingsUI
    Menu, Tray, Add ; separator line
    Menu, Tray, Add, Get Him A Coffee, BuyMeACoffee
    Menu, Tray, Add, QuickQuick Website, VisitPage 
    Menu, Tray, Add ; separator line
    Menu, Tray, Add, Run at Windows Startup, addProgramShortcutLinkToStartupFolder

    If (FileExist(program_lnk_startup_path)){
        Menu, Tray, Check, Run at Windows Startup
    }

    Menu, Tray, Icon, Get Him a Coffee, res\img\btn_coffee.png, 1,16
    Menu, Tray, Add, Reload Program, reloadThisProgram
    Menu, Tray, Tip, QuickQuick
    Menu, Tray, Add, Exit, Exit
    return
}

; ############################################
; ############# PPT TOOLS GUI ################
; ############################################

#If ((WinActive("ahk_exe POWERPNT.EXE") && WinActive("ahk_class PPTFrameClass")) && (checkIfMousePosIsInActiveWindowGui()==true) ) || WinExist("ahk_id" ppt_tools_gui)
ToggleUIKey1:
ToggleUIKey2:
{        
       {
            if (WinExist("ahk_id" ppt_tools_gui)){
                SetTimer, CheckIfPPTFrameClosed, Delete
                GUI %ppt_tools_gui% : Hide
                return
            } else If ((WinActive("ahk_exe POWERPNT.EXE") && WinActive("ahk_class PPTFrameClass")) && (checkIfMousePosIsInActiveWindowGui()==true) ) {
                gosub, Show_QQPPT_Tools_GUI
                return
            }
        }
        
    return
}

Create_QQPPT_Tools_GUI: 
{

    BS_BITMAP    := 0x80
    IMAGE_BITMAP := 0
    BM_SETIMAGE  := 0xF7
    
    ppt_gui_width = 204
    ppt_gui_height = 180
    ppt_gui_warning_height = 42
    
    Gui, 3: New, +Hwndppt_tools_gui
    Gui, 3: Default
    Gui, 3:  +LastFound  +ToolWindow +Owner -Caption +DPIScale ;+AlwaysOnTop
    Gui, Font, q2 s7

    Gui Add, Picture, x32 y6 w21 h21 gBuyMeACoffeeFromPPTToolsGUI vBuyTheDeveloperACoffee, res\img\btn_coffee.png    
    Gui Add, Picture, x6 y6 w21 h21 gVisitPageFromPPTToolsGUI vVisitPage, res\img\QuickQuick.ico
    Gui Add, Picture, x178 y6 w21 h21 g3GuiEscape vCloseUI, res\img\close_hide.png
    gosub, Draw_AutoClose_Option_Button
    
    Gui, Color, f0f0f0
    Gui, Add, Tab3,x3 y30 w198 h150 vPPTToolsTabs, Align/Order|Size/Pos|Shape/Text
    
    Gui, Add, Button, x60 y78 w48 h24 %BS_BITMAP% gpptCallMsoCommandWithArg vObjectsAlignTopSmart hwndhBtn_ObjectsAlignTopSmart
    if !hBitmap := LoadPicture("res\img\ObjectsAlignTopSmart.png", "h24 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_ObjectsAlignTopSmart%

    Gui, Add, Button, x108 y102 w24 h48 %BS_BITMAP% gpptCallMsoCommandWithArg vObjectsAlignRightSmart hwndhBtn_ObjectsAlignRightSmart
    if !hBitmap := LoadPicture("res\img\ObjectsAlignRightSmart.png", "h24 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_ObjectsAlignRightSmart%

    Gui, Add, Button, x60 y150 w48 h24 %BS_BITMAP% gpptCallMsoCommandWithArg vObjectsAlignBottomSmart hwndhBtn_ObjectsAlignBottomSmart
    if !hBitmap := LoadPicture("res\img\ObjectsAlignBottomSmart.png", "h24 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_ObjectsAlignBottomSmart%

    Gui, Add, Button, x36 y102 w24 h48 %BS_BITMAP% gpptCallMsoCommandWithArg vObjectsAlignLeftSmart hwndhBtn_ObjectsAlignLeftSmart
    if !hBitmap := LoadPicture("res\img\ObjectsAlignLeftSmart.png", "h24 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_ObjectsAlignLeftSmart%

    Gui, Add, Button, x36 y54 w24 h24 %BS_BITMAP% gpptCallMsoCommandWithArg vAlignDistributeVertically hwndhBtn_AlignDistributeVertically
    if !hBitmap := LoadPicture("res\img\AlignDistributeVertically.png", "h24 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_AlignDistributeVertically%

    Gui, Add, Button, x108 y54 w24 h24 %BS_BITMAP% gpptCallMsoCommandWithArg vAlignDistributeHorizontally hwndhBtn_AlignDistributeHorizontally
    if !hBitmap := LoadPicture("res\img\AlignDistributeHorizontally.png", "h24 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_AlignDistributeHorizontally%

    Gui, Add, Button, x60 y126 w48 h24 %BS_BITMAP% gpptCallMsoCommandWithArg vObjectSendToBack hwndhBtn_ObjectSendToBack
    if !hBitmap := LoadPicture("res\img\ObjectSendToBack.png", "h24 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_ObjectSendToBack%
    
    Gui, Add, Button, x60 y102 w48 h24 %BS_BITMAP% gpptCallMsoCommandWithArg vObjectBringToFront hwndhBtn_ObjectBringToFront
    if !hBitmap := LoadPicture("res\img\ObjectBringToFront.png", "h24 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_ObjectBringToFront%
    
    Gui, Add, Button, x132 y102 w24 h48 %BS_BITMAP% gpptCallMsoCommandWithArg vObjectsAlignMiddleVerticalSmart hwndhBtn_ObjectsAlignMiddleVerticalSmart
    if !hBitmap := LoadPicture("res\img\ObjectsAlignMiddleVerticalSmart.png", "h24 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_ObjectsAlignMiddleVerticalSmart%

    Gui, Add, Button, x60 y54 w48 h24 %BS_BITMAP% gpptCallMsoCommandWithArg vObjectsAlignCenterHorizontalSmart hwndhBtn_ObjectsAlignCenterHorizontalSmart
    if !hBitmap := LoadPicture("res\img\ObjectsAlignCenterHorizontalSmart.png", "h24 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_ObjectsAlignCenterHorizontalSmart%

    Gui, Tab, 2
    
    Gui, Add, Button, x54 y102 w48 h48 %BS_BITMAP% gQQPPT_CopySizeAndPosition vQQPPT_CopySizeAndPosition hwndhBtn_QQPPT_CopySizeAndPosition
    if !hBitmap := LoadPicture("res\img\QQPPT_CopySizeAndPosition.png", "h42 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_QQPPT_CopySizeAndPosition%

    Gui, Add, Button, x30 y78 w24 h24 %BS_BITMAP% gQQPPT_PastePosition_TopLeft vQQPPT_PastePosition_TopLeft hwndhBtn_QQPPT_PastePosition_TopLeft
    if !hBitmap := LoadPicture("res\img\QQPPT_PastePosition_TopLeft.png", "h24 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_QQPPT_PastePosition_TopLeft%
    
    Gui, Add, Button, x102 y78 w24 h24 %BS_BITMAP% gQQPPT_PastePosition_TopRight vQQPPT_PastePosition_TopRight hwndhBtn_QQPPT_PastePosition_TopRight
    if !hBitmap := LoadPicture("res\img\QQPPT_PastePosition_TopRight.png", "h24 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_QQPPT_PastePosition_TopRight%

    Gui, Add, Button, x102 y150 w24 h24 %BS_BITMAP% gQQPPT_PastePosition_BottomRight vQQPPT_PastePosition_BottomRight hwndhBtn_QQPPT_PastePosition_BottomRight
    if !hBitmap := LoadPicture("res\img\QQPPT_PastePosition_BottomRight.png", "h24 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_QQPPT_PastePosition_BottomRight%

    Gui, Add, Button, x30 y150 w24 h24 %BS_BITMAP% gQQPPT_PastePosition_BottomLeft vQQPPT_PastePosition_BottomLeft hwndhBtn_QQPPT_PastePosition_BottomLeft
    if !hBitmap := LoadPicture("res\img\QQPPT_PastePosition_BottomLeft.png", "h24 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_QQPPT_PastePosition_BottomLeft%


    Gui, Add, Button, x138 y150 w24 h24 %BS_BITMAP% gQQPPT_LockAspectRatio vQQPPT_LockAspectRatio hwndhBtn_QQPPT_LockAspectRatio
    if !hBitmap := LoadPicture("res\img\QQPPT_LockAspectRatio.png", "h24 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_QQPPT_LockAspectRatio%
    
    Gui, Add, Button, x162 y150 w24 h24 %BS_BITMAP% gQQPPT_UnlockAspectRatio vQQPPT_UnlockAspectRatio hwndhBtn_QQPPT_UnlockAspectRatio
    if !hBitmap := LoadPicture("res\img\QQPPT_UnlockAspectRatio.png", "h24 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_QQPPT_UnlockAspectRatio%


    Gui, Add, Button, x102 y54 w24 h24 Disabled %BS_BITMAP% gQQPPT_PasteRoundedCornerRadius vQQPPT_PasteRoundedCornerRadius hwndhBtn_QQPPT_PasteRoundedCornerRadius
    if !hBitmap := LoadPicture("res\img\QQPPT_PasteRoundedCornerRadius.png", "h24 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_QQPPT_PasteRoundedCornerRadius%

    Gui, Font, s6
    Gui Add, Button, x30 y102 w24 h48 gQQPPT_PastePosition_Left vQQPPT_PastePosition_Left hwndhBtn_QQPPT_PastePosition_Left
    Gui Add, Button, x54 y78 w48 h24 gQQPPT_PastePosition_Top vQQPPT_PastePosition_Top  hwndhBtn_QQPPT_PastePosition_Top
    Gui Add, Button, x102 y102 w24 h48 gQQPPT_PastePosition_Right vQQPPT_PastePosition_Right hwndhBtn_QQPPT_PastePosition_Right
    Gui Add, Button, x54 y150 w48 h24 gQQPPT_PastePosition_Bottom vQQPPT_PastePosition_Bottom hwndhBtn_QQPPT_PastePosition_Bottom
    Gui, Font, s8

    Gui, Add, Button, x6 y54 w24 h24 %BS_BITMAP% gQQPPT_PasteSize_WidthAndHeight vQQPPT_PasteSize_WidthAndHeight hwndhBtn_QQPPT_PasteSize_WidthAndHeight
    if !hBitmap := LoadPicture("res\img\QQPPT_PasteSize_WidthAndHeight.png", "h24 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_QQPPT_PasteSize_WidthAndHeight%

    Gui, Font, s6
    Gui Add, Button, x30 y54 w72 h24 gQQPPT_PasteSize_Width vQQPPT_PasteSize_Width hwndhBtn_QQPPT_PasteSize_Width
    Gui Add, Button, x6 y78 w24 h72 gQQPPT_PasteSize_Height vQQPPT_PasteSize_Height hwndhBtn_QQPPT_PasteSize_Height
    Gui, Font, s8
    
    Gui, Tab, 3
    Gui, Add, Text, x108 y60 h114 0x11
    
    Gui Add, Checkbox, x114 y60 h15 w90 vSameFillColor,Fill Color
    Gui Add, Checkbox, x114 y84 h15 w90 vSameOutlineColor,Outline Color
    Gui Add, Checkbox, x114 y108 h15 w90 vSameShapeType,Shape Type
    Gui, Font, s8
    Gui Add, Button, x114 y132 h24 w78 vQQPPT_SelectItemsWithSameAttributes gQQPPT_SelectItemsWithSameAttributes, Select Same


    Gui, Add, Button, x66 y90 w24 h24 %BS_BITMAP% gQQPPT_CopyText vQQPPT_CopyText hwndhBtn_QQPPT_CopyText
    if !hBitmap := LoadPicture("res\img\QQPPT_CopyText.png", "h24 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_QQPPT_CopyText%
    
    Gui, Add, Button, x12 y60 w24 h24 %BS_BITMAP% gQQPPT_ToggleTextMargins vQQPPT_ToggleTextMargins hwndhBtn_QQPPT_ToggleTextMargins
    if !hBitmap := LoadPicture("res\img\QQPPT_ToggleTextMargins.png", "h24 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_QQPPT_ToggleTextMargins%
    
    Gui, Add, Button, x36 y60 w24 h24 %BS_BITMAP% gQQPPT_ToggleParagraphSpacingBefore vQQPPT_ToggleParagraphSpacingBefore hwndhBtn_QQPPT_ToggleParagraphSpacingBefore
    if !hBitmap := LoadPicture("res\img\QQPPT_ToggleParagraphSpacingBefore.png", "h24 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_QQPPT_ToggleParagraphSpacingBefore%
    
    Gui, Add, Button, x66 y60 w24 h24 %BS_BITMAP% gQQPPT_SetAutoSizeOptionToNone vQQPPT_SetAutoSizeOptionToNone hwndhBtn_QQPPT_SetAutoSizeOptionToNone
    if !hBitmap := LoadPicture("res\img\QQPPT_SetAutoSizeOptionToNone.png", "h24 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_QQPPT_SetAutoSizeOptionToNone%

    Gui, Add, Button, x12 y90 w24 h24 %BS_BITMAP% gQQPPT_HideSelectedItems vQQPPT_HideSelectedItems hwndhBtn_QQPPT_HideSelectedItems
    if !hBitmap := LoadPicture("res\img\QQPPT_HideSelectedItems.png", "h24 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_QQPPT_HideSelectedItems%

    Gui, Add, Button, x36 y90 w24 h24 %BS_BITMAP% gQQPPT_ShowAllItems vQQPPT_ShowAllItems hwndhBtn_QQPPT_ShowAllItems
    if !hBitmap := LoadPicture("res\img\QQPPT_ShowAllItems.png", "h24 w-1", IMAGE_BITMAP) 
    {}
    SendMessage, BM_SETIMAGE, IMAGE_BITMAP, hBitmap,, ahk_id %hBtn_QQPPT_ShowAllItems%
    
    return
    
}

Show_QQPPT_Tools_GUI:
{
    SetTimer, CheckIfPPTFrameClosed, Delete
    Gui, %ppt_tools_gui%: Default
    GuiControl , choose, PPTToolsTabs, 1
    gosub, UncheckSelectSameOptions
    
    CoordMode Mouse, Screen
    MouseGetPos, XPos, YPos
    
    XPos_gui :=  XPos - (ppt_gui_width * (A_ScreenDPI/96) * 84/204) 
    YPos_gui := YPos - (ppt_gui_height * (A_ScreenDPI/96) * 114/180) 
    
    WinGetPos, XPos_PPT, YPos_PPT, Width_PPT, Height_PPT, A  ; "A" to get the active window's pos.
 
    ;~ XPos_PPT := XPos_PPT * (A_ScreenDPI/100)
    ;~ YPos_PPT := YPos_PPT * (A_ScreenDPI/100)
    ;~ Width_PPT := Width_PPT * (A_ScreenDPI/100)
    ;~ Height_PPT := Height_PPT * (A_ScreenDPI/100)

    if (XPos_gui < XPos_PPT){
        XPos_gui := XPos_PPT
    } else if ((XPos_gui + (ppt_gui_width * (A_ScreenDPI/96))) > XPos_PPT + Width_PPT){            
        XPos_gui := XPos_PPT + Width_PPT - (ppt_gui_width * (A_ScreenDPI/96))
    }
    
    if (YPos_gui < YPos_PPT){
        YPos_gui := YPos_PPT
    } else if ((YPos_gui + (ppt_gui_height * (A_ScreenDPI/96))) > YPos_PPT + Height_PPT){            
        YPos_gui := YPos_PPT + Height_PPT - (ppt_gui_height * (A_ScreenDPI/96))
    }
    
    active_ppt_frame := winactive("ahk_class PPTFrameClass")
    Gui, %ppt_tools_gui%  : +Owner%active_ppt_frame% 
    Gui, %ppt_tools_gui%  : Show, w%ppt_gui_width% h%ppt_gui_height% x%XPos_gui% y%YPos_gui%
    
    OnMessage(0x200, "WM_MOUSEMOVE_PPT_TOOLS_GUI")
    OnMessage(0x201, "WM_LBUTTONDOWN_PPT_TOOLS_GUI")
    WinSet, Transparent, 225 , ahk_id %ppt_tools_gui% 
    SetTimer, CheckIfPPTFrameClosed, 2000
    return
}

WM_MOUSEMOVE_PPT_TOOLS_GUI()
{
    static CurrControl, PrevControl, _TT 
    CurrControl := A_GuiControl
    
    tooltip_timer := 1500

    If (CurrControl <> PrevControl and not InStr(CurrControl, " ") and (global b_IsHighPriorityTooltipStillOn = false))
    {
        ToolTip
        SetTimer, DisplayPPTToolsBtnToolTip, %tooltip_timer%
        PrevControl := CurrControl
    }
    return

    DisplayPPTToolsBtnToolTip:
    SetTimer, DisplayPPTToolsBtnToolTip, Delete
    
    MouseGetPos, x, y, win, ctrl

    if (win = global ppt_tools_gui){
    
        if (global b_IsHighPriorityTooltipStillOn = false){
            this_ini_file = config.ini
            this_ini_hk_section = PowerPointHotkeys

            this_help_section = PowerPointCommands

            this_btn_hotkey_info := getHotkeyFromIni(this_ini_file, this_ini_hk_section, CurrControl)
            this_btn_hotkey_len := StrLen(this_btn_hotkey_info)
            
            help_text_file = res\help_text
            
            IniRead, this_btn_help_text, % help_text_file, % this_help_section, %CurrControl%

            if (this_btn_help_text="ERROR"){
             this_btn_help_text:=   
            }
            this_btn_help_len := StrLen(this_btn_help_text)
            s_CurrControl_len := StrLen(trim(CurrControl))
            
            
            if (s_CurrControl_len>1) && (this_btn_help_len>0) {
                 
                a_help_text := StrSplit(this_btn_help_text,"|")            
                
                s_help_text_summary := a_help_text[1]
                
                s_help_text_description := a_help_text[2]
                s_help_text_description := stringTextWrap(s_help_text_description)
                

                if (this_btn_hotkey_len > 1){
                    this_btn_hotkey_info := "("translateHotkeys(this_btn_hotkey_info)")"            
                    s_tooltip_string = %s_help_text_summary% %this_btn_hotkey_info%`n%s_help_text_description%
                } else{
                    s_tooltip_string = %s_help_text_summary%`n%s_help_text_description%
                }
            
            s_tooltip_string_len := StrLen(s_tooltip_string)
            
            if (s_tooltip_string_len > 0){
                
                i_tooltip_timer := 1000 + s_tooltip_string_len * 50
                
                ToolTip, %s_tooltip_string%

                }
            
            }   
            
            
        }
        
    }
    
    return

    RemovePPTToolsBtnToolTip:
    SetTimer, RemovePPTToolsBtnToolTip, Delete
    ToolTip
    return
}

WM_LBUTTONDOWN_PPT_TOOLS_GUI(){
   PostMessage 0xA1, 2
}

CheckIfPPTFrameClosed:
{
    if !WinExist("ahk_id" active_ppt_frame){
        SetTimer, CheckIfPPTFrameClosed, Delete
        Gui %ppt_tools_gui%  : Hide
    }
    return
}

SameFillColorOptionClick:
{
    ToggleOption("SameFillColor")
    return
}

SameOutlineColorOptionClick:
{
    ToggleOption("SameOutlineColor")
    return
}

SameShapeTypeOptionClick:
{
    ToggleOption("SameShapeType")
    return
}

UncheckSelectSameOptions:
{
    UncheckOption("SameFillColor")
    UncheckOption("SameOutlineColor")
    UncheckOption("SameShapeType")
    return
}

UncheckOption(cb){
    GuiControl,, %cb%,0
}

ToggleOption(cb){
    
    try{
        GuiControlGet,isChecked,,%cb%
         
        if (isChecked=0){
            GuiControl,, %cb%,1
            } else {
            GuiControl,, %cb%,0
        }
    }
}

Draw_AutoClose_Option_Button:
{
    s_ini_general_section := "General"
    s_auto_close_ppttools_after_execution_config_key := "AutoClosePPTToolsGUIAfterAction"
    IniRead, b_auto_close_ppttools_after_execution, % ini_file, % s_ini_general_section, % s_auto_close_ppttools_after_execution_config_key
    
    if (%b_auto_close_ppttools_after_execution% = true){
        sAutoCloseButtonImagePath = res\img\AutoClose_On.png
    } else {
        sAutoCloseButtonImagePath = res\img\AutoClose_Off.png
    }
    
    Gui Add, Picture, x154 y6 w21 h21 gToggleGUIAutoCloseOption vToggleGUIAutoCloseOption, %sAutoCloseButtonImagePath%
    return
}

ToggleGUIAutoCloseOption:
{
    s_ini_general_section := "General"
    s_auto_close_ppttools_after_execution_config_key := "AutoClosePPTToolsGUIAfterAction"
    IniRead, b_auto_close_ppttools_after_execution, % ini_file, % s_ini_general_section, % s_auto_close_ppttools_after_execution_config_key
    
    if (%b_auto_close_ppttools_after_execution% = true){
        showHighPriorityTooltip("Auto Close = Off",2000)
        IniWrite, false, % ini_file, % s_ini_general_section, % s_auto_close_ppttools_after_execution_config_key 
        GuiControl,, ToggleGUIAutoCloseOption, res\img\AutoClose_Off.png
    } else {
        showHighPriorityTooltip("Auto Close = On",2000)
        IniWrite, true, % ini_file, % s_ini_general_section, % s_auto_close_ppttools_after_execution_config_key 
        GuiControl,, ToggleGUIAutoCloseOption, res\img\AutoClose_On.png
    }
    
    return
}

PPTToolsGUIAutoclose:
{
    s_ini_general_section := "General"
    
    s_auto_close_ppttools_after_execution_config_key := "AutoClosePPTToolsGUIAfterAction"
    IniRead, b_auto_close_ppttools_after_execution, % ini_file, % s_ini_general_section, % s_auto_close_ppttools_after_execution_config_key
    
    try{
        if !GetKeyState("Ctrl", "P") {
            if (b_auto_close_ppttools_after_execution="True"){
                SetTimer, CheckIfPPTFrameClosed, Delete
                GUI %ppt_tools_gui% : Hide
            }
        }
    }
    return
}

BuyMeACoffeeFromPPTToolsGUI:
{
    gosub, BuyMeACoffee
    gosub, PPTToolsGUIAutoclose
    return
}

BuyMeACoffee:
{
    run, https://quickquick.page.link/coffee
    return
}

VisitPageFromPPTToolsGUI:
{
    gosub, VisitPage
    gosub, PPTToolsGUIAutoclose
    return
}

VisitPage:
{
    run, https://quickquick.page.link/qqppthome
    return
}

getActivePPT(){
    objectPPT = 
    try{
    objectPPT := ComObjActive("PowerPoint.application")
    } 
	return objectPPT
}

getActiveXL(){
    objectXL = 
    try{
    objectXL := ComObjActive("Excel.application")
    }
	return objectXL
}

activatePPTWin(){
    WinActivate ahk_exe POWERPNT.EXE
    WinActivate ahk_class PPTFrameClass
}

activateXLWin(){
    WinActivate ahk_exe EXCEL.EXE
    WinActivate ahk_class XLMAIN
}

checkIfMousePosIsInActiveWindowGui(){
    CoordMode Mouse, Screen
    MouseGetPos, mouseX,mouseY
    WinGetPos, winX,winY,winWidth,winHeight,A
    if (mouseX >= winX && mouseX <= winX + winwidth && mouseY >= winY && mouseY <= winY+ winHeight){
        return true
    } else {
        return false
    }
}


; ############################################
; ####### POWERPOINT COMMAND FUNCTIONS #######
; ############################################

pptRemoveShapeColor(){
    activePPT := getActivePPT()
    activatePPTWin()
    
    try{
        pptShapes := activePPT.ActiveWindow.Selection.ShapeRange
        if (pptShapes.count >= 1){
            for sh in pptShapes{
                
                IfEqual, A_GuiControl, RemoveFillColor
                    sh.Fill.Visible := false
                
                else IfEqual, A_GuiControl, RemoveOutlineColor
                    sh.Line.Visible := false
        }
        }
    }
    GUI, Hide
}

pptGetShapeRoundedCornerRadius(sh){
    
    sngRadius := "ERROR"
    shpType := pptGetObjectAutoshapeType(sh)
    
    if (shpType = 5) || (shpType = 151) || (shpType = 152) || (shpType = 153) || (shpType = 154)  {
        try{
            If (sh.Width < sh.Height) {
                sngRadius := sh.Width * sh.Adjustments(1)
              } Else if sh.Width >= sh.Height {
                sngRadius := sh.Height * sh.Adjustments(1)
              } 
          } 
      }
    return sngRadius
}

pptPasteRoundedCornerRadius(){
    
    if (ppt_last_copied_rounded_corner_radius !=""){
    
        activePPT := getActivePPT()
        activatePPTWin()
        
        try{
            pptShapes := activePPT.ActiveWindow.Selection.ShapeRange
            
            if (pptShapes.count >= 1){
                try{
                    pptShapes := activePPT.ActiveWindow.Selection.ShapeRange
                    

                        for sh in pptShapes{
                            if (pptShapes.count = 1 && pptCheckIsGroup(sh) = true){
                                ChildrenCount := 0

                                try {    
                                    for subSh in activePPT.ActiveWindow.Selection.ChildShapeRange{
                                        ChildrenCount := ChildrenCount + 1
                                        subShType := pptGetObjectAutoshapeType(subSh)
                                       
                                        if (subShType = 5) || (subShType = 151) || (subShType = 152) || (subShType = 153) || (subShType = 154) {
                                            try{
                                                If (subSh.Width < subSh.Height){
                                                    subSh.Adjustments(1) := ppt_last_copied_rounded_corner_radius / subSh.Width
                                                } else if (subSh.Width >= subSh.Height){
                                                    subSh.Adjustments(1) := ppt_last_copied_rounded_corner_radius / subSh.Height
                                                }
                                            }
                                        }
                                    }
                                } catch e {
                                    
                                    if (ChildrenCount < 1){
                                        
                                        for subSh in sh.GroupItems{
                                        ;~ MsgBox, B
                                            subShType := pptGetObjectAutoshapeType(subSh)

                                            if (subShType = 5) || (subShType = 151) || (subShType = 152) || (subShType = 153) || (subShType = 154) {
                                                try{
                                                    If (subSh.Width < subSh.Height){
                                                        subSh.Adjustments(1) := ppt_last_copied_rounded_corner_radius / subSh.Width
                                                    } else if (subSh.Width >= subSh.Height){
                                                        subSh.Adjustments(1) := ppt_last_copied_rounded_corner_radius / subSh.Height
                                                    }
                                                }
                                            }
                                            
                                        }
                                            
                                    }                                    
                                    
                                }
                                
                            } else {
                                   
                                        
                                        if (pptCheckIsGroup(sh) = true){
            
                                            for subSh in sh.GroupItems{
                                                
                                                subShType := pptGetObjectAutoshapeType(subSh)

                                                if (subShType = 5) || (subShType = 151) || (subShType = 152) || (subShType = 153) || (subShType = 154) {
                                                    try{
                                                        If (subSh.Width < subSh.Height){
                                                            subSh.Adjustments(1) := ppt_last_copied_rounded_corner_radius / subSh.Width
                                                        } else if (subSh.Width >= subSh.Height){
                                                            subSh.Adjustments(1) := ppt_last_copied_rounded_corner_radius / subSh.Height
                                                        }
                                                    }
                                                }
                                                
                                            }
                                        
                                        } Else {
                                        
                                            shpType := pptGetObjectAutoshapeType(sh)
                                        
                                            if (shpType = 5) || (shpType = 151) || (shpType = 152) || (shpType = 153) || (shpType = 154) {
                                        
                                            try{
                                                    If (sh.Width < sh.Height){
                                                        sh.Adjustments(1) := ppt_last_copied_rounded_corner_radius / sh.Width
                                                    } else if (sh.Width >= sh.Height){                                            
                                                        sh.Adjustments(1) := ppt_last_copied_rounded_corner_radius / sh.Height
                                                    }
                                                }
                                        }
                                        
                                    }
                                }
                            }
                    }
                }
            }
            
    }
}

pptToggleTextMargins(){
    
    activePPT := getActivePPT()
    activatePPTWin()
    cur_margin :=
    new_margin :=
    cur_margin_str_len := 0
    ChildrenCount := 0
    shIndex := 0
    margin_zero := 0
    margin_narrow := 2
    margin_moderate := 8
    margin_wide := 16
    
            try{
                pptShapes := activePPT.ActiveWindow.Selection.ShapeRange
                if (pptShapes.count >= 1){
                    for sh in pptShapes{
                        
                        shIndex := shIndex + 1

                        if (pptShapes.count = 1 && pptCheckIsGroup(sh) = true){
                            
                            try {    
                                for subSh in activePPT.ActiveWindow.Selection.ChildShapeRange{
                                    
                                    ChildrenCount := ChildrenCount + 1
                                    
                                    if ((ChildrenCount = 1)|| (cur_margin_str_len = 0)){
                                        try{
                                            cur_margin := subSh.TextFrame.MarginLeft
                                        }
                                        cur_margin_str_len := StrLen(cur_margin)
                                    
                                        
                                        if (cur_margin_str_len=0){
                                            goto, toggle_text_margin_next_subshape                                
                                        }
                                    }
                                    

                                    if (cur_margin = margin_zero){
                                        new_margin := margin_narrow
                                        } else if (cur_margin = margin_narrow){
                                        new_margin := margin_moderate
                                        } else if (cur_margin = margin_moderate){
                                        new_margin := margin_wide
                                        } else {
                                        new_margin := margin_zero
                                    }
                                    
                                    try{
                                        subSh.TextFrame.MarginBottom := new_margin
                                        subSh.TextFrame.MarginLeft := new_margin
                                        subSh.TextFrame.MarginRight := new_margin
                                        subSh.TextFrame.MarginTop := new_margin
                                    }
                                    
                                    toggle_text_margin_next_subshape:
                                }
                            } catch e {
                                if (ChildrenCount < 1){
                                    
                                    if ((shIndex = 1) || (cur_margin_str_len = 0)){
                                        try{
                                            cur_margin := sh.TextFrame.MarginLeft
                                        }
                                        cur_margin_str_len := StrLen(cur_margin)
                            
                                        if (cur_margin_str_len=0){
                                            goto, toggle_text_margin_next_shape                                
                                        }
                                    }
                                    
                                    if (cur_margin = margin_zero){
                                        new_margin := margin_narrow
                                        } else if (cur_margin = margin_narrow){
                                        new_margin := margin_moderate
                                        } else if (cur_margin = margin_moderate){
                                        new_margin := margin_wide
                                        } else {
                                        new_margin := margin_zero
                                    }
                                    
                                    try{
                                        sh.TextFrame.MarginBottom := new_margin  
                                        sh.TextFrame.MarginLeft := new_margin
                                        sh.TextFrame.MarginRight := new_margin
                                        sh.TextFrame.MarginTop := new_margin
                                    }
                                }
                            }
                            
                        } else {
                            
                            if ((shIndex = 1) || (cur_margin_str_len = 0)){
                                try{
                                    cur_margin := sh.TextFrame.MarginLeft
                                }
                                cur_margin_str_len := StrLen(cur_margin)
                                
                                if (cur_margin_str_len=0){
                                    goto, toggle_text_margin_next_shape                                
                                }
                            }
                            
                            if (cur_margin = margin_zero){
                                new_margin := margin_narrow
                                } else if (cur_margin = margin_narrow){
                                new_margin := margin_moderate
                                } else if (cur_margin = margin_moderate){
                                new_margin := margin_wide
                                } else {
                                new_margin := margin_zero
                            }
                            
                            try{
                                sh.TextFrame.MarginBottom := new_margin
                                sh.TextFrame.MarginLeft := new_margin
                                sh.TextFrame.MarginRight := new_margin
                                sh.TextFrame.MarginTop := new_margin
                            }
                        }
                        toggle_text_margin_next_shape:
                    }
                    
                }
            }
            
            if (new_margin=margin_zero){
            s_new_margin_tooltip := "Text margins = Zero"
            } else if (new_margin=margin_narrow) {
                s_new_margin_tooltip := "Text margins = Narrow"
            } else if (new_margin=margin_moderate){
                s_new_margin_tooltip := "Text margins = Moderate"
            } else if (new_margin=margin_wide){
                s_new_margin_tooltip := "Text margins = Wide"
            }
            
            if (s_new_margin_tooltip !=""){
                showHighPriorityTooltip(s_new_margin_tooltip,2000)
            }

}

pptToggleParagraphSpacingBefore(){
    
    activePPT := getActivePPT()
    activatePPTWin()
    cur_spacing :=
    new_spacing :=
    cur_spacing_str_len := 0
    ChildrenCount := 0
    shIndex := 0
    spacing_zero := 0
    spacing_narrow := 6
    spacing_moderate := 12
    spacing_wide := 18
    
            try{
                pptShapes := activePPT.ActiveWindow.Selection.ShapeRange
                if (pptShapes.count >= 1){
                    for sh in pptShapes{
                        
                        shIndex := shIndex + 1

                        if (pptShapes.count = 1 && pptCheckIsGroup(sh) = true){
                            
                            try {    
                                for subSh in activePPT.ActiveWindow.Selection.ChildShapeRange{
                                    
                                    ChildrenCount := ChildrenCount + 1
                                    
                                    if ((ChildrenCount = 1)|| (cur_spacing_str_len = 0)){
                                        try{
                                            cur_spacing := subSh.TextFrame.TextRange.ParagraphFormat.SpaceBefore
                                        }
                                        cur_spacing_str_len := StrLen(cur_spacing)
                                    
                                        
                                        if (cur_spacing_str_len=0){
                                            goto, toggle_text_spacing_next_subshape                                
                                        }
                                    }
                                    

                                    if (cur_spacing = spacing_zero){
                                        new_spacing := spacing_narrow
                                        } else if (cur_spacing = spacing_narrow){
                                        new_spacing := spacing_moderate
                                        } else if (cur_spacing = spacing_moderate){
                                        new_spacing := spacing_wide
                                        } else {
                                        new_spacing := spacing_zero
                                    }
                                    
                                    try{
                                        subSh.TextFrame.TextRange.ParagraphFormat.SpaceBefore := new_spacing
                                    }
                                    
                                    toggle_text_spacing_next_subshape:
                                }
                            } catch e {
                                if (ChildrenCount < 1){
                                    
                                    if ((shIndex = 1) || (cur_spacing_str_len = 0)){
                                        try{
                                            cur_spacing := sh.TextFrame.TextRange.ParagraphFormat.SpaceBefore
                                        }
                                        cur_spacing_str_len := StrLen(cur_spacing)
                            
                                        if (cur_spacing_str_len=0){
                                            goto, toggle_text_spacing_next_shape                                
                                        }
                                    }
                                    
                                    if (cur_spacing = spacing_zero){
                                        new_spacing := spacing_narrow
                                        } else if (cur_spacing = spacing_narrow){
                                        new_spacing := spacing_moderate
                                        } else if (cur_spacing = spacing_moderate){
                                        new_spacing := spacing_wide
                                        } else {
                                        new_spacing := spacing_zero
                                    }
                                    
                                    try{
                                        sh.TextFrame.TextRange.ParagraphFormat.SpaceBefore := new_spacing  
                                    }
                                }
                            }
                            
                        } else {
                            
                            if ((shIndex = 1) || (cur_spacing_str_len = 0)){
                                try{
                                    cur_spacing := sh.TextFrame.TextRange.ParagraphFormat.SpaceBefore
                                }
                                cur_spacing_str_len := StrLen(cur_spacing)
                                
                                if (cur_spacing_str_len=0){
                                    goto, toggle_text_spacing_next_shape                                
                                }
                            }
                            
                            if (cur_spacing = spacing_zero){
                                new_spacing := spacing_narrow
                                } else if (cur_spacing = spacing_narrow){
                                new_spacing := spacing_moderate
                                } else if (cur_spacing = spacing_moderate){
                                new_spacing := spacing_wide
                                } else {
                                new_spacing := spacing_zero
                            }
                            
                            try{
                                sh.TextFrame.TextRange.ParagraphFormat.SpaceBefore := new_spacing
                            }
                        }
                        toggle_text_spacing_next_shape:
                    }
                    
                }
                
        }            
            
            
            
            if (new_spacing=spacing_zero){
                s_new_spacing := "Paragraph spacing = Zero"
                } else if (new_spacing=spacing_narrow) {
                    s_new_spacing := "Paragraph spacing = Narrow"
                } else if (new_spacing=spacing_moderate){
                    s_new_spacing := "Paragraph spacing = Moderate"
                } else if (new_spacing=spacing_wide){
                    s_new_spacing := "Paragraph spacing = Wide"
            }
            
            if (s_new_spacing !=""){
                showHighPriorityTooltip(s_new_spacing,2000)
            }
}

pptSetAutosizeOptions(i_mode){
    
    ;~ i_mode enum:
    ;~ 0 : No autofit
    ;~ 1 : Resize shape to fit text
    ;~ 2 : Shrink text on overflow
    
    activePPT := getActivePPT()
    activatePPTWin()
    cur_autosize_option :=
    new_autosize_option :=
    cur_autosize_option_len := 0
    ChildrenCount := 0
    shIndex := 0
    
            try{
                pptShapes := activePPT.ActiveWindow.Selection.ShapeRange
                if (pptShapes.count >= 1){
                    for sh in pptShapes{
                        
                    try{
                        shIndex := shIndex + 1

                        if (pptShapes.count = 1 && pptCheckIsGroup(sh) = true){
                            
                            try {    
                                for subSh in activePPT.ActiveWindow.Selection.ChildShapeRange{
                                    
                                    ChildrenCount := ChildrenCount + 1
                                    
                                    try{
                                        subSh.TextFrame2.Autosize := i_mode
                                    }
                                    
                                }
                            } catch e {
                                if (ChildrenCount < 1){
                                    try{
                                        sh.TextFrame2.Autosize := i_mode
                                    }
                                }
                            }
                            
                        } else {
                            try{
                                sh.TextFrame2.Autosize := i_mode
                            }
                            
                        
                    }
                }
                    
                }
            }
    }        
}

pptPasteSize(i_mode){
    
    ;~ i_mode enum:
    ;~ 1 : width
    ;~ 2 : heigh
    ;~ 3 : width andd height
    
    activePPT := getActivePPT()
    activatePPTWin()
    
    try{
        pptShapes := activePPT.ActiveWindow.Selection.ShapeRange
        
        if (pptShapes.count >= 1){
            try{
                pptShapes := activePPT.ActiveWindow.Selection.ShapeRange
                
                if ((ppt_last_copied_width > 0) && (i_mode = 1)) || ((ppt_last_copied_height > 0) && (i_mode = 2)) || (((ppt_last_copied_width > 0) || (ppt_last_copied_height > 0)) && (i_mode = 3)) {
                    for sh in pptShapes{
                        if (pptShapes.count = 1 && pptCheckIsGroup(sh) = true){
                            ChildrenCount := 0
                            ;~ MsgBox, % pptShapes.count
                            try {    
                                for subSh in activePPT.ActiveWindow.Selection.ChildShapeRange{
                                    ChildrenCount := ChildrenCount + 1
                                     
                                    if (i_mode = 1) || (i_mode = 3){
                                        subSh.Width := ppt_last_copied_width
                                    }
                                    
                                    if (i_mode = 2) || (i_mode = 3){
                                        subSh.Height := ppt_last_copied_height
                                    }
                                    
                                }
                            } catch e {
                                
                                if (ChildrenCount < 1){
                                    
                                    for subSh in sh.GroupItems{

                                        try{
                                            if (i_mode = 1) || (i_mode = 3){
                                                subSh.Width := ppt_last_copied_width
                                            }
                                            
                                            if (i_mode = 2) || (i_mode = 3){
                                                subSh.Height := ppt_last_copied_height
                                            }
                                        
                                        }
                                        
                                    }
                                    
                                }
                            }
                            
                        } else {
                                try
                                {
                                        if (i_mode = 1) || (i_mode = 3){
                                            sh.Width := ppt_last_copied_width
                                        }
                                        
                                        if (i_mode = 2) || (i_mode = 3){
                                            sh.Height := ppt_last_copied_height
                                        }
                                }
                            }
                        }
                    }
                    
                }
            }
        }
}

pptMakeItemsSameSize(i_mode){
    activePPT := getActivePPT()
    activatePPTWin()
    max_width := 0
    max_height := 0
    
    try{
        pptShapes := activePPT.ActiveWindow.Selection.ShapeRange
        if (pptShapes.count >= 1){
            for sh in pptShapes{
                if (pptShapes.count = 1 && pptCheckIsGroup(sh) = true){
                    ChildrenCount :=
                    
                    try {    
                        for subSh in activePPT.ActiveWindow.Selection.ChildShapeRange{
                            ChildrenCount := ChildrenCount + 1
                            if (max_width < subSh.Width) {
                                max_width := subSh.Width
                            }
                            if (max_height < subSh.Height) {
                                max_height := subSh.Height
                            }
                        }
                    } catch e {
                        
                        if (ChildrenCount < 1){
                        
                            for subSh in sh.GroupItems{
                                if (max_width < subSh.Width) {
                                    max_width := subSh.Width
                                }
                                if (max_height < subSh.Height) {
                                    max_height := subSh.Height
                                }
                            
                            }
                            
                        }
                    }
                    
                } else {
                        if (max_width < sh.Width) {
                            max_width := sh.Width
                            
                        }
                        if (max_height < sh.Height) {
                            max_height := sh.Height
                     
                        }
                }
            }
        
        if ((max_width > 0) && (i_mode = 1)) || ((max_height > 0) && (i_mode = 2)) || ((max_width > 0) && (max_height > 0) && (i_mode = 3)) {
            for sh in pptShapes{
                if (pptShapes.count = 1 && pptCheckIsGroup(sh) = true){
                    ChildrenCount := 0

                    try {    
                        for subSh in activePPT.ActiveWindow.Selection.ChildShapeRange{
                            ChildrenCount := ChildrenCount + 1

                            try{
                                if (i_mode = 1) || (i_mode = 3){
                                    subSh.Width := max_width
                                }
                                
                                if (i_mode = 2) || (i_mode = 3){
                                    subSh.Height := max_height
                                }
                            }
                            
                        }
                    } catch e {
                        
                        if (ChildrenCount < 1){
                        
                            for subSh in sh.GroupItems{
                            
                                try{
                                    if (i_mode = 1) || (i_mode = 3){
                                        subSh.Width := max_width
                                    }
                                    
                                    if (i_mode = 2) || (i_mode = 3){
                                        subSh.Height := max_height
                                    }
                                }
                            
                            }
                            
                        }
                    }
                    
                } else {
                    
                        try{
                            
                            if (i_mode = 1) || (i_mode = 3){
                                sh.Width := max_width
                            }
                            
                            if (i_mode = 2) || (i_mode = 3){
                                sh.Height := max_height
                            }
                        }
                }
            }
        }
        }
    }
}

pptHideItems(){
    activePPT := getActivePPT()
    activatePPTWin()
    
    try{
        pptShapes := activePPT.ActiveWindow.Selection.ShapeRange
        if (pptShapes.count >= 1){
            for sh in pptShapes{
                if (pptShapes.count = 1 && pptCheckIsGroup(sh) = true){
                    hiddenChildrenCount :=
                    
                    try {    
                        for subSh in activePPT.ActiveWindow.Selection.ChildShapeRange{
                            hiddenChildrenCount := hiddenChildrenCount + 1
                            try{
                                subSh.Visible := False
                            }
                        }
                    } catch e {
                        if (hiddenChildCount < 1){
                            try{
                                sh.Visible := False
                            }
                        }
                    }
                    
                } else {
                    try{
                        sh.Visible := false
                    }
                }
            }
        }
    }
}

pptShowAllItems(){
    activePPT := getActivePPT()
    activatePPTWin()
    
    try{
        pptShapes := activePPT.ActiveWindow.View.Slide.Shapes
        if (pptShapes.count >= 1){
            for sh in pptShapes{
                try{
                    sh.Visible := true        
                }
            }
        }
    }
}

pptCopyTextFromSelection(){
    activePPT := getActivePPT()
    activatePPTWin()
    outString :=
    
    try{
        pptShapes := activePPT.ActiveWindow.Selection.ShapeRange
        if (pptShapes.count >= 1){
            for sh in pptShapes{
                
                if (pptCheckIsGroup(sh) = true){
                    
                    for subSh in sh.GroupItems{
                        try{
                            outString .= subSh.TextFrame.TextRange.Text "`n"                        
                        }
                    }                    
                } else if (pptCheckIsTable(sh) = true) {
                   loop, % sh.Table.Rows.Count{
                        i_index := A_Index
                        loop, % sh.Table.Columns.Count {
                           try{                                
                                outString .= sh.Table.Cell(i_index,A_Index).Shape.TextFrame.TextRange.Text "`t"         
                            } 
                        }
                        outString .= "`n"
                    }
                } else {
                    try{
                        outString .= sh.TextFrame.TextRange.Text "`n"                        
                    }
                }                
            }                    
        }
    }
    if (outString != ""){
        Clipboard := outString
        showHighPriorityTooltip("Text copied to clipboard",2000)
    }
}

pptSelectShapesWithSameAttributes(ppt_SameFillColor:=0,ppt_SameOutlineColor:=0,ppt_SameShapeType:=0){

    activePPT := getActivePPT()
    activatePPTWin()
    
    showHighPriorityTooltip("Selecting items with same attribute(s)",2000)
    
    try{
        pptShapes := activePPT.ActiveWindow.Selection.ShapeRange
        
        if (pptShapes.count == 1){
            
            selectedShape := activePPT.ActiveWindow.Selection.ShapeRange(1)
            
            if (pptCheckIsGroup(selectedShape) = false) {
            
                findFillColor := pptGetObjectFillColor(selectedShape)
                findOutlineColor := pptGetObjectLineColor(selectedShape)
                findShapeType := pptGetObjectShapeType(selectedShape)
                findAutoShapeType := pptGetObjectAutoshapeType(selectedShape)
                
                
                if ((findFillColor != "ERROR" || ppt_SameFillColor =0) && (findOutlineColor != "ERROR" || ppt_SameOutlineColor =0) && (((findShapeType != "ERROR") && (findShapeType>0) )|| ppt_SameShapeType = 0) ) {
                    for sh in activePPT.ActiveWindow.View.Slide.Shapes

                        if ( ( pptGetObjectFillColor(sh) == findFillColor || ppt_SameFillColor = 0) 
                            && (pptGetObjectLineColor(sh) == findOutlineColor || ppt_SameOutlineColor = 0) 
                            && (((findShapeType == 1) && (pptGetObjectShapeType(sh)==1) &&  (pptGetObjectAutoshapeType(sh) == findAutoShapeType)) || ((findShapeType != 1) &&  (pptGetObjectShapeType(sh) == findShapeType)) || (ppt_SameShapeType = 0 )) 
                            && (pptCheckIsGroup(sh)=false)){
                        
                         sh.Select(Replace:=False)
                        }

                    }
                }
                
            } else {
                ;ppt_gui_warning_update("Please select only one object before executing this action")
        }
    } catch e {
        ;ppt_gui_warning_update("Please select an object before executing this action")  
    }
}

convertPointForDisplay(pnt){
    RegRead, iMeasure, HKEY_CURRENT_USER, Control Panel\International, iMeasure
    
    if (iMeasure = 0){
        displayOutput := pnt * 0.03527778
    } else {
        displayOutput := pnt / 72
    }
    return %displayOutput%
}

pptLockAspectRatio(i_mode){

    activePPT := getActivePPT()
    activatePPTWin()
    
    try{
        pptShapes := activePPT.ActiveWindow.Selection.ShapeRange
        
        if (pptShapes.count >= 1){
            for sh in pptShapes{
                if (pptShapes.count = 1 && pptCheckIsGroup(sh) = true){
                    childrenCount :=
                    
                    try {    
                        for subSh in activePPT.ActiveWindow.Selection.ChildShapeRange{
                            childrenCount := childrenCount + 1
                            try{
                                subSh.LockAspectRatio := i_mode
                            }
                        }
                    } catch e {
                        if (childrenCount < 1){
                            try{
                                sh.LockAspectRatio := i_mode
                            }
                        }
                    }
                    
                } else {
                    try{
                        sh.LockAspectRatio := i_mode
                    }
                }
            }
        }
    }
    
}

pptCopySizeAndPosition(){
    activePPT := getActivePPT()
    activatePPTWin()
    
    try{
        pptShapes := activePPT.ActiveWindow.Selection.ShapeRange
        
        if (pptShapes.count == 1){
            
            
            selectedShape := activePPT.ActiveWindow.Selection.ShapeRange(1)
            
            if (pptCheckIsGroup(selectedShape) = true){
                    ChildrenCount := 0
                    
                    try {    
                        for subSh in activePPT.ActiveWindow.Selection.ChildShapeRange{
                            ChildrenCount := ChildrenCount + 1
                        }
                        if (ChildrenCount = 1){
                            selectedShape := subSh

                        } else {
                           goto, pptCopySizeAndPosition_too_many_items_selected
                        }
                    
                    } catch e {
                        
                        if (ChildrenCount < 1){
                            selectedShape := activePPT.ActiveWindow.Selection.ShapeRange(1)
                            
                            }
                            
                        }
            } 
            
  
            global ppt_last_copied_position_left := selectedShape.Left
            global ppt_last_copied_position_top := selectedShape.Top
            global ppt_last_copied_position_right := selectedShape.Left + selectedShape.width
            global ppt_last_copied_position_bottom := selectedShape.top + selectedShape.height
            global ppt_last_copied_width := selectedShape.width
            global ppt_last_copied_height := selectedShape.height
            
            
            global ppt_last_copied_rounded_corner_radius := pptGetShapeRoundedCornerRadius(selectedShape)
            
            if (ppt_last_copied_rounded_corner_radius = "ERROR")
            {
                ppt_last_copied_rounded_corner_radius := ""
            }
            
            try{
                if (ppt_last_copied_rounded_corner_radius != ""){                    
                        GuiControl, 3: Enable, QQPPT_PasteRoundedCornerRadius                    
                } else {                    
                        GuiControl, 3: Disable, QQPPT_PasteRoundedCornerRadius                    
                }
            }
            
            formatted_number_copied_position_left := Round(convertPointForDisplay(ppt_last_copied_position_left),2)
            formatted_number_copied_position_top := Round(convertPointForDisplay(ppt_last_copied_position_top),2)
            formatted_number_copied_position_right := Round(convertPointForDisplay(ppt_last_copied_position_right),2)
            formatted_number_copied_position_bottom := Round(convertPointForDisplay(ppt_last_copied_position_bottom),2)
            formatted_number_copied_width := Round(convertPointForDisplay(ppt_last_copied_width),2)
            formatted_number_copied_height := Round(convertPointForDisplay(ppt_last_copied_height),2)
            
            s_tooltip = Size & Position copied: `n W:%formatted_number_copied_width% H:%formatted_number_copied_height% `n L:%formatted_number_copied_position_left% T:%formatted_number_copied_position_top% `n R:%formatted_number_copied_position_right% B:%formatted_number_copied_position_bottom%
            showHighPriorityTooltip(s_tooltip , 6000)
            
            GuiControl, 3: ,  QQPPT_PastePosition_Left, %formatted_number_copied_position_left%
            GuiControl, 3: ,  QQPPT_PastePosition_Top, %formatted_number_copied_position_top%
            GuiControl, 3: ,  QQPPT_PastePosition_Right, %formatted_number_copied_position_right%
            GuiControl, 3: ,  QQPPT_PastePosition_Bottom, %formatted_number_copied_position_bottom%
            GuiControl, 3: ,  QQPPT_PasteSize_Width, %formatted_number_copied_width%
            GuiControl, 3: ,  QQPPT_PasteSize_Height, %formatted_number_copied_height%
        }
        pptCopySizeAndPosition_too_many_items_selected:
    }
}

pptPastePosition(i_mode){
    
    activePPT := getActivePPT()
    activatePPTWin()
    
    try{
        pptShapes := activePPT.ActiveWindow.Selection.ShapeRange
        
        if (pptShapes.count >= 1){
            try{
                pptShapes := activePPT.ActiveWindow.Selection.ShapeRange
                
                
                    for sh in pptShapes{
                        if (pptShapes.count = 1 && pptCheckIsGroup(sh) = true){
                            ChildrenCount := 0
                            ;~ MsgBox, % pptShapes.count
                            try {    
                                for subSh in activePPT.ActiveWindow.Selection.ChildShapeRange{
                                    ChildrenCount := ChildrenCount + 1
                                     
                                    if (i_mode = 1) || (i_mode = 2) || (i_mode = 8){
                                        try{
                                            subSh.Left := ppt_last_copied_position_left
                                        }
                                    }
                                    
                                    if (i_mode = 2) || (i_mode = 3) || (i_mode = 4){                
                                        try{
                                            subSh.Top := ppt_last_copied_position_top
                                        }
                                    }
                                    
                                    if (i_mode = 4) || (i_mode = 5) || (i_mode = 6){                
                                        try{
                                            subSh.Left := ppt_last_copied_position_right - sh.width
                                        }
                                    }
                                    
                                    if (i_mode = 6) || (i_mode = 7) || (i_mode = 8){                
                                        try{
                                            subSh.Top := ppt_last_copied_position_bottom - sh.height
                                        }
                                    }
                                    
                                    
                                }
                            } catch e {
                                
                                if (ChildrenCount < 1){
                                    
                                        if (i_mode = 1) || (i_mode = 2) || (i_mode = 8){
                                            try{
                                                sh.Left := ppt_last_copied_position_left
                                            }
                                        }
                                        
                                        if (i_mode = 2) || (i_mode = 3) || (i_mode = 4){                
                                            try{
                                                sh.Top := ppt_last_copied_position_top
                                            }
                                        }
                                        
                                        if (i_mode = 4) || (i_mode = 5) || (i_mode = 6){                
                                            try{
                                                sh.Left := ppt_last_copied_position_right - sh.width
                                            }
                                        }
                                        
                                        if (i_mode = 6) || (i_mode = 7) || (i_mode = 8){                
                                            try{
                                                sh.Top := ppt_last_copied_position_bottom - sh.height
                                            }
                                        }
                                    
                                }
                            }
                            
                        } else {
                                if (i_mode = 1) || (i_mode = 2) || (i_mode = 8){
                                    try{
                                        sh.Left := ppt_last_copied_position_left
                                    }
                                }
                                
                                if (i_mode = 2) || (i_mode = 3) || (i_mode = 4){                
                                    try{
                                        sh.Top := ppt_last_copied_position_top
                                    }
                                }
                                
                                if (i_mode = 4) || (i_mode = 5) || (i_mode = 6){                
                                    try{
                                        sh.Left := ppt_last_copied_position_right - sh.width
                                    }
                                }
                                
                                if (i_mode = 6) || (i_mode = 7) || (i_mode = 8){                
                                    try{
                                        sh.Top := ppt_last_copied_position_bottom - sh.height
                                    }
                                }
                            }
                        }
                }
            }
        }
}

pptCheckIsGroup(shape){
    
    is_Group_Boolean = 0
    
    try{
        itemsCount:= shape.GroupItems.Count
        if (itemsCount>0){
            return 1
        }
    } catch e {
        return 0
    }

    
}

pptCheckIsTable(shape){
    if (shape.Type = 19){
        return True
    } else if (shape.Type = 14){
       ; MsgBox, % shape.PlaceholderFormat.ContainedType
        if (shape.PlaceholderFormat.ContainedType = 19){
            return true 
            }
    } else {
        return false    
    }
}

pptGetObjectFillColor(ppt_object){
    try {
        return ppt_object.Fill.ForeColor.RGB
        } catch {
        return "ERROR"
        }
}

pptGetObjectLineColor(ppt_object){
    try {
        return ppt_object.Line.ForeColor.RGB
        } catch {
        return "ERROR"
        }
}

pptGetObjectShapeType(ppt_object){
    try {
        return ppt_object.Type
        } catch {
        return "ERROR"
        }
}

pptGetObjectAutoshapeType(ppt_object){
    try {
        return ppt_object.AutoShapeType
        } catch {
        return "ERROR"
        }
}

pptCallMsoCommandWithArg(){
    activePPT := getActivePPT()
	
    try{
    		activePPT.CommandBars.ExecuteMso(A_GuiControl)
	}
    gosub, PPTToolsGUIAutoclose
    return
}

; ############################################
; ############# HOTKEYS TOOLS ###############
; ############################################

RegisterHotkeysForPowerPoint:
{
    IniRead, listOfPPTHotkeys, % ini_file, % ppt_ini_hk_section
    IniRead, listOfPPTFunctions, % cmdList_file, % ppt_cmdList_section
    
    StringSplit, pptHotkeys, listOfPPTHotkeys, `n
    StringSplit, pptFunctions, listOfPPTFunctions, `n

    Hotkey, IfWinActive, ahk_class PPTFrameClass 
    
    Loop, % pptFunctions0
    {
        line := pptFunctions%A_Index%
        pptFunctionSub%A_Index% := SubStr(line, 1, InStr(line, "=") - 1)
        pptFunctionHotkey%A_Index% := getHotkeyFromIni(ini_file, ppt_ini_hk_section, pptFunctionSub%A_Index%)
        tmp_hk := pptFunctionHotkey%A_Index%
        tmp_hk := translateHotkeys(tmp_hk)
        
        StringLen, hk_len, pptFunctionHotkey%A_Index%
        StringLen, fn_len, pptFunctionSub%A_Index%
        ErrorLevel = 0
        if (hk_len > 1) AND (fn_len > 1){
            try{
                Hotkey, % pptFunctionHotkey%A_Index% , ExecuteHotkeyCommandForPowerPoint,UseErrorLevel
                 
                if (ErrorLevel = 2) {
                    string_hotkey_registration_error_lang_layout = %string_hotkey_registration_error_lang_layout%PowerPoint : %tmp_hk%`n
                }
                }
        }
    }
    
    return
}
    
RegisterHotkeysForExcel:
{
    IniRead, listOfXLHotkeys, % ini_file, % xl_ini_hk_section
    IniRead, listOfXLFunctions, % cmdList_file, % xl_cmdList_section
    
    StringSplit, xlHotkeys, listOfXLHotkeys, `n
    StringSplit, xlFunctions, listOfXLFunctions, `n

    Hotkey, IfWinActive, ahk_class XLMAIN
 
    Loop, % xlFunctions0
    {
        line := xlFunctions%A_Index%
        xlFunctionSub%A_Index% := SubStr(line, 1, InStr(line, "=") - 1)
        xlFunctionHotkey%A_Index% := getHotkeyFromIni(ini_file, xl_ini_hk_section, xlFunctionSub%A_Index%)
        tmp_hk := xlFunctionHotkey%A_Index%
        tmp_hk := translateHotkeys(tmp_hk)
        
        StringLen, hk_len, xlFunctionHotkey%A_Index%
        StringLen, fn_len, xlFunctionSub%A_Index%
        ErrorLevel = 0
        if (hk_len > 1) AND (fn_len > 1){
            try{
                Hotkey, % xlFunctionHotkey%A_Index% , ExecuteHotkeyCommandForExcel,UseErrorLevel
                
                if (ErrorLevel = 2) {
                    
                    string_hotkey_registration_error_lang_layout = %string_hotkey_registration_error_lang_layout%Excel : %tmp_hk%`n
                }
                }
        }
    }
    
    return
}

ShowHotkeysRegistrationErrorIfAny:
{
    StringLen, err_len, string_hotkey_registration_error_lang_layout
    
    if (err_len > 0)  
    {        
     MsgBox, ,QuickQuick - Hotkeys Registration Errors,Unable to register the following hotkeys for the active keyboard layout/language:`n`n%string_hotkey_registration_error_lang_layout%`nTry switching the keyboard language/layout and reload this program or avoid using the said hotkeys which may not work well across different keyboard languages/layouts you're using.
    }
    
    string_hotkey_registration_error_lang_layout:=

    return
}

ExecuteHotkeyCommandForExcel:
{        
    IniRead, curCommand, % ini_file, % xl_ini_hk_section, % A_ThisHotkey
    IniRead, curDescription, % cmdList_file, % xl_cmdList_section, % curCommand
    
    draw_mode_search_string:= "(Draw Mode)"
    
    ToolTip, QuickQuick : %curCommand%
    SetTimer, RemoveToolTip, -1000
    
    if islabel(curCommand){
      gosub, % curCommand
    } else {
        
        IfInString, A_ThisHotkey, ^ 
        {                
            IfInString, curDescription, % draw_mode_search_string
            {   
                Send {Blind}{Ctrl up}
            }
        }
        
        xlCallMsoCommandWithArgFromHotkey(curCommand)
        
    }

return
}

ExecuteHotkeyCommandForPowerPoint:
{        
    IniRead, curCommand, % ini_file, % ppt_ini_hk_section, % A_ThisHotkey
    IniRead, curDescription, % cmdList_file, % ppt_cmdList_section, % curCommand
    
    draw_mode_search_string:= "(Draw Mode)"
    
    
    if islabel(curCommand){
        gosub, % curCommand
    } else {
        
        ToolTip, QuickQuick : %curCommand%
        SetTimer, RemoveToolTip, -1000
        

        IfInString, A_ThisHotkey, ^ 
        {                
            IfInString, curDescription, % draw_mode_search_string
            {   
                Send {Blind}{Ctrl up}
            }
        }
        
        
        pptCallMsoCommandWithArgFromHotkey(curCommand)
    }

return
}

ShowXlHotkeySettingsUI:
{
    ini_hk_section := xl_ini_hk_section
    cmdList_section := xl_cmdList_section

    str_hotkey_list_GUI_title := "QuickQuick - Hotkeys Configuration for Excel"
    
    gosub, ShowHotkeySettingsUI
    return
}

ShowPptHotkeySettingsUI:
{
    ini_hk_section := ppt_ini_hk_section
    cmdList_section := ppt_cmdList_section

    str_hotkey_list_GUI_title := "QuickQuick - Hotkeys Configuration for PowerPoint"
    
    gosub, ShowHotkeySettingsUI
    return
 }   

ShowHotkeySettingsUI:
{

    IniRead, listOfHotkeys, % ini_file, % ini_hk_section
    IniRead, listOfFunctions, % cmdList_file, % cmdList_section
     
    StringSplit, officeHotkeys, listOfHotkeys, `n
    StringSplit, officeFunctions, listOfFunctions, `n 

    Menu, Tray, Disable, Hotkeys for PowerPoint
    Menu, Tray, Disable, Hotkeys for Excel
    
    Gui, 1: New, +Hwndgui_hotkey_list
    Gui 1: Default
    Gui, -MaximizeBox -MinimizeBox +AlwaysOnTop -SysMenu
    
    Gui, Font, Bold s8
    Gui, Add, Text, y8 w45, Filter:
    Gui, Font, Normal s8
    Gui, Add, Edit, y5 x45 vFilterKeyword w150
    
    Gui, Add, Button ,y5 x200 w65 gFilterListView Default, Search
    Gui Add, Checkbox, x270 y8 h15 gFilterListView vShowOnlyActionsWithHotkey, Show only items with registered hotkeys
    Gui, Add, Button ,y5 x485 w65 gHotkeySetUIFilterReset, Reset Filter
    
    ShowOnlyActionsWithHotkey:=0
    
    Gui, Add, ListView, xm r20 w720 h300 vHotkeyListView gHotkeyListView, Action|Description|Hotkey
    GuiControl, -Multi, HotkeyListView
    Gui, Add, Button, x595 y340 w135 h35 gGuiClose,Close && Apply Changes
    
    gosub, FilterHotkeySettingsUI

    Menu, HotkeyListViewContextMenu, Add, Edit Hotkey, ContextEditHotkey
    Menu, HotkeyListViewContextMenu, Add, Delete Hotkey, ContextEditHotkey
    Menu, HotkeyListViewContextMenu, Default, Edit Hotkey  ; Make "Edit" a bold font to indicate that double-click does the same thing.

    LV_ModifyCol(1, 200)
    LV_ModifyCol(2, 330)
    LV_ModifyCol(3, 165)
    
    LV_ModifyCol(1, "Sort") 
    
    Gui, %gui_hotkey_list% : Show,, %str_hotkey_list_GUI_title%
    OnMessage(0x102, "WM_CHAR_FILTER")        
    return
}


FilterHotkeySettingsUI:
{
    FilterKeyword := trim(FilterKeyword)
    len_FilterKeyword := StrLen(FilterKeyword)
    
    keywordsSearchResult := false
    
      Loop, % officeFunctions0
          {
          line := officeFunctions%A_Index%
          
          if (len_FilterKeyword > 0){
            keywordsSearchResult := searchMultipleMatch(line, FilterKeyword)
            }
    
                  if (%keywordsSearchResult% == true) or (len_FilterKeyword == 0)
                      {
                          officeFunctionSub%A_Index% := SubStr(line, 1, InStr(line, "=") - 1)
                          officeFunctionName%A_Index% := SubStr(line, Instr(line, "=") + 1 )
                          officeFunctionHotkey%A_Index% := getHotkeyFromIni(ini_file, ini_hk_section, officeFunctionSub%A_Index%)
                          displayHotkeys := translateHotkeys(officeFunctionHotkey%A_Index%) 
                          
                          StringLen,hotkey_len,displayHotkeys
                          
                          if (ShowOnlyActionsWithHotkey=0) OR (ShowOnlyActionsWithHotkey=1 AND hotkey_len > 1){
                            LV_Add(,officeFunctionSub%A_Index%, officeFunctionName%A_Index%, displayHotkeys)            
                        }
                      }
          }
    return
}

searchMultipleMatch(textStr, inputStr){
	
    result = false

	StringSplit,searchKeywords ,inputStr," "
	Loop, % searchKeywords0 {
    
    input_len := StrLen(searchKeywords%A_Index%)
    
		if (input_len > 0){
            
			if  textStr contains % searchKeywords%A_Index% 
            {
                result = true
			
            } else {
                
				result = false
				return result
                
            }
            
        } 
	}
	
	return result
}

FilterListView:
{
    Gui, %gui_hotkey_list% : Submit, NoHide
    LV_Delete()

    gosub, FilterHotkeySettingsUI
    return
}


HotkeyListView:
{
    if (A_GuiEvent = "DoubleClick")  ; There are many other possible values the script can check.
    {
        LV_GetText(cur_Action, A_EventInfo, 1) 
        LV_GetText(cur_Hotkeys, A_EventInfo, 3)
        showHotkeySettingGUI(cur_Action, cur_Hotkeys)
    }
    return
}

GuiContextMenu: 
{
    if (A_GuiControl != "HotkeyListView")
        return
    Menu, HotkeyListViewContextMenu, Show, %A_GuiX%, %A_GuiY%x
    return
}

ContextEditHotkey: 
{
    FocusedRowNumber := LV_GetNext(0, "F")  ; Find the focused row.
    if not FocusedRowNumber  ; No row is focused.
        return
    LV_GetText(cur_Action, FocusedRowNumber, 1)
    LV_GetText(cur_Hotkeys, FocusedRowNumber, 3)
    if InStr(A_ThisMenuItem, "Delete Hotkey")  {
        gosub, ClearHotkeys
    } else  if InStr(A_ThisMenuItem, "Edit Hotkey")  {
        showHotkeySettingGUI(cur_Action, cur_Hotkeys)
    }
    return
}

showHotkeySettingGUI(cur_action, cur_Hotkeys){
    
    Gui 1: Hide
    Gui 2: Default
    Gui, 2: New, +Hwndgui_hotkey_setting
    
    Gui, Font, Bold s14
    Gui -MaximizeBox -MinimizeBox +AlwaysOnTop -SysMenu
    Gui, Add, Hotkey, x5 h35 w355 vHK gSetHotkeys, HotkeySetUI
    Gui, Font, Normal s8
    Gui, Add, Button, x200 y60 w80 h30 gClearHotkeys, Delete Hotkey
    Gui, Add, Button, x280 y60 w80 h30 g2GuiClose, Cancel
   
    ActionToClearHotkeys := cur_action
    Gui, %gui_hotkey_setting%: Show, , QuickQuick - Set Hotkey for %cur_action%
    return
}

RemoveOldHotkeys:
{
    HotkeysToClear := getHotkeyFromIni(ini_file, ini_hk_section, cur_Action)
    StringLen, pvhk_len, HotkeysToClear
   
    if (pvhk_len>0){
        IniDelete, % ini_file, % ini_hk_section, %HotkeysToClear%
        FocusedRowNumber := LV_GetNext(0, "F")
        LV_Modify(FocusedRowNumber, "Col3","")
    }
    return
}

ClearHotkeys:
{
    Gui, %gui_hotkey_setting%: Destroy
    Gui, %gui_hotkey_list% :Default
    
    gosub, RemoveOldHotkeys
    Gui, Show
    Return
}

SetHotkeys:
{
    If HK in +,^,!,+^,+!,^!,+^!,          ;If the hotkey contains only modifiers, return to wait for a key.
        return
      
    If (HK = "") {
        return                             
    }

    IfInString, HK, = 
    {
        MsgBox,4160,, The equal (=) sign is not supported
        return   
    }

    IfInString, HK, \
    {
        MsgBox,4160,, The backspace key (\) is not supported
        return   
    }
    
    IfInString, HK, CapsLock
    {
        MsgBox,4160,, The Caps Lock key is not supported
        return   
    }

    IfNotInString, HK, !
    {
        IfNotInString, HK, ^        ; If no modifer (alt / ctrl) key detected, return to wait for one
        {
            return
        }
    }
        
    Gui, %gui_hotkey_setting% : Submit, NoHide                  
    Gui, %gui_hotkey_setting% : Destroy
    
    StringLen, action_len, cur_Action
    StringLen, HK_len, HK
    
    Gui %gui_hotkey_list% : Default
        
    if (action_len > 2) AND (HK_len>1)
    {
        gosub, RemoveOldHotkeys
        removeDuplicateHotkey(HK)
        IniWrite, % cur_Action, % ini_file, % ini_hk_section, % HK
    }
    
    FocusedRowNumber := LV_GetNext(0, "F")
    LV_Modify(FocusedRowNumber, "Col3",translateHotkeys(HK))
    Gui, %gui_hotkey_list% : Show
    return
}

HotkeySetUIFilterReset:
{
    GuiControl,,FilterKeyword,
    GuiControl,,ShowOnlyActionsWithHotkey,0
    ShowOnlyActionsWithHotkey:=0
    gosub, FilterListView
    return
}

removeDuplicateHotkey(HK_to_check){

    Loop % LV_GetCount()
    {
        LV_GetText(RetrievedText, A_Index,3)
        if (RetrievedText = translateHotkeys(HK_to_check))
            LV_Modify(A_Index, "Col3","")
    }
    return
}

getHotkeyFromIni(s_inifile, s_section,s_targetvalue){
        
    found_hotkey :=    
    
    IniRead, listOfHotkeys, % s_inifile, % s_section
    StringSplit, officeHotkeys, listOfHotkeys, `n
    
    Loop, % officeHotkeys0
        {
            line_hotkey_configs := officeHotkeys%A_Index%
            
            officeDefinedHotkey%A_Index% := SubStr(line_hotkey_configs, 1, InStr(line_hotkey_configs, "=") - 1)
            officeTargetFunction%A_Index% := SubStr(line_hotkey_configs, Instr(line_hotkey_configs, "=") + 1 )
            
            if (officeTargetFunction%A_Index% = s_targetvalue){
                found_hotkey := officeDefinedHotkey%A_Index%
        }
    }
    
    return % found_hotkey
}

translateHotkeys(s_hk){
    StringReplace, s_hk, s_hk, +, Shift+
    StringReplace, s_hk, s_hk, <^>!, AltGr+ 
    StringReplace, s_hk, s_hk, <, Left, All
    StringReplace, s_hk, s_hk, >, Right, All 
    StringReplace, s_hk, s_hk, !, Alt+ 
    StringReplace, s_hk, s_hk, ^, Ctrl+ 
    StringReplace, s_hk, s_hk, #, Win+ 
    StringUpper, s_hk, s_hk
    return  s_hk
}
    
pptCallMsoCommandWithArgFromHotkey(mso_command){  
    
    activePPT := getActivePPT()
    
    if (activePPT == ""){
        createAndDestroyDummyGui()
        Sleep, 100
        activePPT := getActivePPT()
    }
    
    try{
    		activePPT.CommandBars.ExecuteMso(mso_command)
	}
    return
}

xlCallMsoCommandWithArgFromHotkey(mso_command){  

    activeXL := getActiveXL()

    if (activeXL == ""){
        createAndDestroyDummyGui()
        Sleep, 100
        activeXL := getActiveXL()
    }

    try{
    		activeXL.CommandBars.ExecuteMso(mso_command)
	}

    return
}

createAndDestroyDummyGui(){
    ; this is only a workaround - without this, the script may fail to get the active Excel/PowerPoint instance
    ; the issue occurs only with some machines, no idea what causes this
    Gui 9 : Add, Text,,
    Gui 9 : -Caption +ToolWindow
    Gui 9 : Show
    Gui 9 : Destroy
    return
}


WM_CHAR_FILTER(wParam, lParam){

	If(A_GuiControl = "FilterKeyword" and !RegExMatch(Chr(wParam), "i)^[a-z1-9\s\x08]$"))
		Return false

}

; ############################################
; ########### CLOSING / ESCAPING #############
; ############################################

GuiEscape:
{
    Reload
    return
}
 
GuiClose:
{
    Reload
    return
}

2GuiEscape:
{
    Gui, %gui_hotkey_setting% : Destroy
    Gui, %gui_hotkey_list% : Default
    Gui, %gui_hotkey_list% : Show
    return
}

2GuiClose:
{
    gosub, 2GuiEscape
    return
}

3GuiEscape:
{
    SetTimer, CheckIfPPTFrameClosed, Delete
    Gui, %ppt_tools_gui%: Hide
    return
}

Exit:
{
    ExitApp
}
    

; ############################################
; ################# MISC #####################
; ############################################

addProgramShortcutLinkToStartupFolder(){
    global program_lnk_startup_path
    If (FileExist(program_lnk_startup_path)){
        try{
            FileDelete, %program_lnk_startup_path%
            Menu, Tray, Uncheck, Run at Windows Startup
        }
    } else{
        try{
            FileCreateShortcut,%A_ScriptFullPath%, %program_lnk_startup_path%
            Menu, Tray, Check, Run at Windows Startup       
        }
    }
    return
}

reloadThisProgram(){
    Reload
    return
}


stringTextWrap(s_in){
    
    Loop % (StrLen(s_in) // 50) {
        s_in := RegExReplace(s_in, " ", "`n",, 1, 50 * A_Index)
    }   
    return %s_in%
}

RemoveToolTip:
{
    SetTimer,RemoveToolTip, Delete
    ToolTip
    return
}

showHighPriorityTooltip(s_text,i_timer){
    global b_IsHighPriorityTooltipStillOn = true
    ToolTip, % s_text
    SetTimer, removeHighPriorityTooltip, % i_timer   
}

removeHighPriorityTooltip(){
    global b_IsHighPriorityTooltipStillOn = false
    SetTimer,removeHighPriorityTooltip, Delete
    ToolTip
}

; ############################################
; ###### POWERPOINT PRODUCTIVITY TOOLS #######
; ############################################

QQPPT_HideSelectedItems:
{
    pptHideItems()
    showHighPriorityTooltip("Hiding selected item(s)",1000)
    gosub, PPTToolsGUIAutoclose
    return
}
        
QQPPT_ShowAllItems:
{
    pptShowAllItems()
    showHighPriorityTooltip("Unhiding all item(s) in slide",2000)
    gosub, PPTToolsGUIAutoclose
    return
}
    
QQPPT_MakeSameHeight:
{
    pptMakeItemsSameSize(2)
    return
}

QQPPT_MakeSameWidth:
{
    pptMakeItemsSameSize(1)
    return
}

QQPPT_MakeSameWidthAndHeight:
{
    pptMakeItemsSameSize(3)
    return
}

QQPPT_ToggleTextMargins:
{
    pptToggleTextMargins()
    return
}
    
QQPPT_ToggleParagraphSpacingBefore:
{
    pptToggleParagraphSpacingBefore()
    return
}

QQPPT_SetAutoSizeOptionToNone:
{
    pptSetAutosizeOptions(0)
    showHighPriorityTooltip("Setting AutoSize option to None",2000)
    gosub, PPTToolsGUIAutoclose
    return
}
    
QQPPT_PasteSize_Width:
{
    pptPasteSize(1)
    showHighPriorityTooltip("Pasting size : Width",2000)
    gosub, PPTToolsGUIAutoclose
    return
}

QQPPT_PasteSize_Height:
{
    pptPasteSize(2)
    showHighPriorityTooltip("Pasting size : Height",2000)
    gosub, PPTToolsGUIAutoclose
    return
}

QQPPT_PasteSize_WidthAndHeight:
{
    pptPasteSize(3)
    showHighPriorityTooltip("Pasting size : Width & Height",2000)
    gosub, PPTToolsGUIAutoclose
    return
}

QQPPT_CopySizeAndPosition:
{
    pptCopySizeAndPosition()
    return
}

QQPPT_PastePosition_Left:
{
    pptPastePosition(1)
    showHighPriorityTooltip("Pasting position : Left",2000)
    gosub, PPTToolsGUIAutoclose
    return
}

QQPPT_PastePosition_TopLeft:
{
    pptPastePosition(2)
    showHighPriorityTooltip("Pasting position : Top Left",2000)
    gosub, PPTToolsGUIAutoclose
    return
}

QQPPT_PastePosition_Top:
{
    pptPastePosition(3)
    showHighPriorityTooltip("Pasting position : Top",2000)
    gosub, PPTToolsGUIAutoclose
    return
}

QQPPT_PastePosition_TopRight:
{
    pptPastePosition(4)
    showHighPriorityTooltip("Pasting position : Top Right",2000)
    gosub, PPTToolsGUIAutoclose
    return
}

QQPPT_PastePosition_Right:
{
    pptPastePosition(5)
    showHighPriorityTooltip("Pasting position : Right",2000)
    gosub, PPTToolsGUIAutoclose
    return
}

QQPPT_PastePosition_BottomRight:
{
    pptPastePosition(6)
    showHighPriorityTooltip("Pasting position : Bottom Right",2000)
    gosub, PPTToolsGUIAutoclose
    return
}

QQPPT_PastePosition_Bottom:
{
    pptPastePosition(7)
    showHighPriorityTooltip("Pasting position : Bottom",2000)
    gosub, PPTToolsGUIAutoclose
    return
}

QQPPT_PastePosition_BottomLeft:
{
    pptPastePosition(8)
    showHighPriorityTooltip("Pasting position : Bottom Left",2000)
    gosub, PPTToolsGUIAutoclose
    return
}
    
QQPPT_LockAspectRatio:
{
    pptLockAspectRatio(-1)
    showHighPriorityTooltip("Locking aspect ratio",2000)
    gosub, PPTToolsGUIAutoclose
    return
}

QQPPT_UnlockAspectRatio:
{
    pptLockAspectRatio(0)
    showHighPriorityTooltip("Unlocking aspect ratio",2000)
    gosub, PPTToolsGUIAutoclose
    return
}

QQPPT_PasteRoundedCornerRadius:
{
    pptPasteRoundedCornerRadius()
    showHighPriorityTooltip("Pasting rounded corner radius",2000)
    gosub, PPTToolsGUIAutoclose
    return
}

QQPPT_CopyText:
{
    Gui, Submit, NoHide
    pptCopyTextFromSelection()
    gosub, PPTToolsGUIAutoclose
    return
}

QQPPT_SelectItemsWithSameAttributes:
{
    Gui, Submit, NoHide
    if (SameFillColor + SameOutlineColor + SameShapeType > 0){
        pptSelectShapesWithSameAttributes(%SameFillColor%, %SameOutlineColor%, %SameShapeType%)    
        gosub, PPTToolsGUIAutoclose
    } else {
        showHighPriorityTooltip("Please select at least one attribute first",2000)       
    }
    return
}
